/*
 * Copyright (c) 2015-2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __ATLAS7_CLKC_H__
#define __ATLAS7_CLKC_H__

#include <io.h>

#define _CLKC_REG_BASE 0x18620000

#ifdef __ATLAS7_STEP_B__

#define A7DA_CLKC_MEMPLL_AB_FREQ			(_CLKC_REG_BASE + 0x0000)
#define A7DA_CLKC_MEMPLL_AB_SSC				(_CLKC_REG_BASE + 0x0004)
#define A7DA_CLKC_MEMPLL_AB_CTRL0			(_CLKC_REG_BASE + 0x0008)
#define A7DA_CLKC_MEMPLL_AB_CTRL1			(_CLKC_REG_BASE + 0x000C)
#define A7DA_CLKC_MEMPLL_AB_STATUS			(_CLKC_REG_BASE + 0x0010)
#define A7DA_CLKC_MEMPLL_AB_SSRAM_ADDR		(_CLKC_REG_BASE + 0x0014)
#define A7DA_CLKC_MEMPLL_AB_SSRAM_DATA		(_CLKC_REG_BASE + 0x0018)
#define A7DA_CLKC_CPUPLL_AB_FREQ			(_CLKC_REG_BASE + 0x001C)
#define A7DA_CLKC_CPUPLL_AB_SSC				(_CLKC_REG_BASE + 0x0020)
#define A7DA_CLKC_CPUPLL_AB_CTRL0			(_CLKC_REG_BASE + 0x0024)
#define A7DA_CLKC_CPUPLL_AB_CTRL1			(_CLKC_REG_BASE + 0x0028)
#define A7DA_CLKC_CPUPLL_AB_STATUS			(_CLKC_REG_BASE + 0x002C)
#define A7DA_CLKC_SYS0_BTPLL_AB_FREQ		(_CLKC_REG_BASE + 0x0030)
#define A7DA_CLKC_SYS0_BTPLL_AB_SSC			(_CLKC_REG_BASE + 0x0034)
#define A7DA_CLKC_SYS0_BTPLL_AB_CTRL0			(_CLKC_REG_BASE + 0x0038)
#define A7DA_CLKC_SYS0_BTPLL_AB_CTRL1			(_CLKC_REG_BASE + 0x003C)
#define A7DA_CLKC_SYS0_BTPLL_AB_STATUS			(_CLKC_REG_BASE + 0x0040)
#define A7DA_CLKC_SYS1_USBPLL_AB_FREQ			(_CLKC_REG_BASE + 0x0044)
#define A7DA_CLKC_SYS1_USBPLL_AB_SSC			(_CLKC_REG_BASE + 0x0048)
#define A7DA_CLKC_SYS1_USBPLL_AB_CTRL0			(_CLKC_REG_BASE + 0x004C)
#define A7DA_CLKC_SYS1_USBPLL_AB_CTRL1			(_CLKC_REG_BASE + 0x0050)
#define A7DA_CLKC_SYS1_USBPLL_AB_STATUS			(_CLKC_REG_BASE + 0x0054)
#define A7DA_CLKC_SYS2_ETHPLL_AB_FREQ			(_CLKC_REG_BASE + 0x0058)
#define A7DA_CLKC_SYS2_ETHPLL_AB_SSC			(_CLKC_REG_BASE + 0x005C)
#define A7DA_CLKC_SYS2_ETHPLL_AB_CTRL0			(_CLKC_REG_BASE + 0x0060)
#define A7DA_CLKC_SYS2_ETHPLL_AB_CTRL1			(_CLKC_REG_BASE + 0x0064)
#define A7DA_CLKC_SYS2_ETHPLL_AB_STATUS			(_CLKC_REG_BASE + 0x0068)
#define A7DA_CLKC_SYS3_SSCPLL_AB_FREQ			(_CLKC_REG_BASE + 0x006C)
#define A7DA_CLKC_SYS3_SSCPLL_AB_SSC			(_CLKC_REG_BASE + 0x0070)
#define A7DA_CLKC_SYS3_SSCPLL_AB_CTRL0			(_CLKC_REG_BASE + 0x0074)
#define A7DA_CLKC_SYS3_SSCPLL_AB_CTRL1			(_CLKC_REG_BASE + 0x0078)
#define A7DA_CLKC_SYS3_SSCPLL_AB_STATUS			(_CLKC_REG_BASE + 0x007C)
#define A7DA_CLKC_SYS3_SSCPLL_AB_SSRAM_ADDR		(_CLKC_REG_BASE + 0x0080)
#define A7DA_CLKC_SYS3_SSCPLL_AB_SSRAM_DATA		(_CLKC_REG_BASE + 0x0084)
#define A7DA_CLKC_AUDIO_DTO_INC				(_CLKC_REG_BASE + 0x0088)
#define A7DA_CLKC_DISP0_DTO_INC				(_CLKC_REG_BASE + 0x008C)
#define A7DA_CLKC_DISP1_DTO_INC				(_CLKC_REG_BASE + 0x0090)
#define A7DA_CLKC_AUDIO_DTO_SRC				(_CLKC_REG_BASE + 0x0094)
#define A7DA_CLKC_AUDIO_DTO_ENA				(_CLKC_REG_BASE + 0x0098)
#define A7DA_CLKC_AUDIO_DTO_DROFF			(_CLKC_REG_BASE + 0x009C)
#define A7DA_CLKC_DISP0_DTO_SRC				(_CLKC_REG_BASE + 0x00A0)
#define A7DA_CLKC_DISP0_DTO_ENA				(_CLKC_REG_BASE + 0x00A4)
#define A7DA_CLKC_DISP0_DTO_DROFF			(_CLKC_REG_BASE + 0x00A8)
#define A7DA_CLKC_DISP1_DTO_SRC				(_CLKC_REG_BASE + 0x00AC)
#define A7DA_CLKC_DISP1_DTO_ENA				(_CLKC_REG_BASE + 0x00B0)
#define A7DA_CLKC_DISP1_DTO_DROFF			(_CLKC_REG_BASE + 0x00B4)
#define A7DA_CLKC_I2S_CLK_SEL				(_CLKC_REG_BASE + 0x00B8)
#define A7DA_CLKC_I2S_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00BC)
#define A7DA_CLKC_USBPHY_CLK_CFG			(_CLKC_REG_BASE + 0x00C0)
#define A7DA_CLKC_USBPHY_CLK_DIVENA			(_CLKC_REG_BASE + 0x00C4)
#define A7DA_CLKC_USBPHY_CLK_SEL			(_CLKC_REG_BASE + 0x00C8)
#define A7DA_CLKC_USBPHY_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00CC)
#define A7DA_CLKC_BTSS_CLK_CFG				(_CLKC_REG_BASE + 0x00D0)
#define A7DA_CLKC_BTSS_CLK_DIVENA			(_CLKC_REG_BASE + 0x00D4)
#define A7DA_CLKC_BTSS_CLK_SEL				(_CLKC_REG_BASE + 0x00D8)
#define A7DA_CLKC_BTSS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00DC)
#define A7DA_CLKC_RGMII_CLK_CFG				(_CLKC_REG_BASE + 0x00E0)
#define A7DA_CLKC_RGMII_CLK_DIVENA			(_CLKC_REG_BASE + 0x00E4)
#define A7DA_CLKC_RGMII_CLK_SEL				(_CLKC_REG_BASE + 0x00E8)
#define A7DA_CLKC_RGMII_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00EC)
#define A7DA_CLKC_CPU_CLK_CFG				(_CLKC_REG_BASE + 0x00F0)
#define A7DA_CLKC_CPU_CLK_DIVENA			(_CLKC_REG_BASE + 0x00F4)
#define A7DA_CLKC_CPU_CLK_SEL				(_CLKC_REG_BASE + 0x00F8)
#define A7DA_CLKC_CPU_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00FC)
#define A7DA_CLKC_SDPHY01_CLK_CFG			(_CLKC_REG_BASE + 0x0100)
#define A7DA_CLKC_SDPHY01_CLK_DIVENA		(_CLKC_REG_BASE + 0x0104)
#define A7DA_CLKC_SDPHY01_CLK_SEL			(_CLKC_REG_BASE + 0x0108)
#define A7DA_CLKC_SDPHY01_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x010C)
#define A7DA_CLKC_SDPHY23_CLK_CFG			(_CLKC_REG_BASE + 0x0110)
#define A7DA_CLKC_SDPHY23_CLK_DIVENA		(_CLKC_REG_BASE + 0x0114)
#define A7DA_CLKC_SDPHY23_CLK_SEL			(_CLKC_REG_BASE + 0x0118)
#define A7DA_CLKC_SDPHY23_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x011C)
#define A7DA_CLKC_SDPHY45_CLK_CFG			(_CLKC_REG_BASE + 0x0120)
#define A7DA_CLKC_SDPHY45_CLK_DIVENA		(_CLKC_REG_BASE + 0x0124)
#define A7DA_CLKC_SDPHY45_CLK_SEL			(_CLKC_REG_BASE + 0x0128)
#define A7DA_CLKC_SDPHY45_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x012C)
#define A7DA_CLKC_SDPHY67_CLK_CFG			(_CLKC_REG_BASE + 0x0130)
#define A7DA_CLKC_SDPHY67_CLK_DIVENA		(_CLKC_REG_BASE + 0x0134)
#define A7DA_CLKC_SDPHY67_CLK_SEL			(_CLKC_REG_BASE + 0x0138)
#define A7DA_CLKC_SDPHY67_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x013C)
#define A7DA_CLKC_CAN_CLK_CFG				(_CLKC_REG_BASE + 0x0140)
#define A7DA_CLKC_CAN_CLK_DIVENA			(_CLKC_REG_BASE + 0x0144)
#define A7DA_CLKC_CAN_CLK_SEL				(_CLKC_REG_BASE + 0x0148)
#define A7DA_CLKC_CAN_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x014C)
#define A7DA_CLKC_DEINT_CLK_CFG				(_CLKC_REG_BASE + 0x0150)
#define A7DA_CLKC_DEINT_CLK_DIVENA			(_CLKC_REG_BASE + 0x0154)
#define A7DA_CLKC_DEINT_CLK_SEL				(_CLKC_REG_BASE + 0x0158)
#define A7DA_CLKC_DEINT_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x015C)
#define A7DA_CLKC_NAND_CLK_CFG				(_CLKC_REG_BASE + 0x0160)
#define A7DA_CLKC_NAND_CLK_DIVENA			(_CLKC_REG_BASE + 0x0164)
#define A7DA_CLKC_NAND_CLK_SEL				(_CLKC_REG_BASE + 0x0168)
#define A7DA_CLKC_NAND_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x016C)
#define A7DA_CLKC_DISP0_CLK_CFG				(_CLKC_REG_BASE + 0x0170)
#define A7DA_CLKC_DISP0_CLK_DIVENA			(_CLKC_REG_BASE + 0x0174)
#define A7DA_CLKC_DISP0_CLK_SEL				(_CLKC_REG_BASE + 0x0178)
#define A7DA_CLKC_DISP0_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x017C)
#define A7DA_CLKC_DISP1_CLK_CFG				(_CLKC_REG_BASE + 0x0180)
#define A7DA_CLKC_DISP1_CLK_DIVENA			(_CLKC_REG_BASE + 0x0184)
#define A7DA_CLKC_DISP1_CLK_SEL				(_CLKC_REG_BASE + 0x0188)
#define A7DA_CLKC_DISP1_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x018C)
#define A7DA_CLKC_GPU_CLK_CFG				(_CLKC_REG_BASE + 0x0190)
#define A7DA_CLKC_GPU_CLK_DIVENA			(_CLKC_REG_BASE + 0x0194)
#define A7DA_CLKC_GPU_CLK_SEL				(_CLKC_REG_BASE + 0x0198)
#define A7DA_CLKC_GPU_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x019C)
#define A7DA_CLKC_GNSS_CLK_CFG				(_CLKC_REG_BASE + 0x01A0)
#define A7DA_CLKC_GNSS_CLK_DIVENA			(_CLKC_REG_BASE + 0x01A4)
#define A7DA_CLKC_GNSS_CLK_SEL				(_CLKC_REG_BASE + 0x01A8)
#define A7DA_CLKC_GNSS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01AC)
#define A7DA_CLKC_SHARED_DIVIDERS_CFG0		(_CLKC_REG_BASE + 0x01B0)
#define A7DA_CLKC_SHARED_DIVIDERS_CFG1		(_CLKC_REG_BASE + 0x01B4)
#define A7DA_CLKC_SHARED_DIVIDERS_ENA		(_CLKC_REG_BASE + 0x01B8)
#define A7DA_CLKC_SYS_CLK_SEL				(_CLKC_REG_BASE + 0x01BC)
#define A7DA_CLKC_SYS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01C0)
#define A7DA_CLKC_IO_CLK_SEL				(_CLKC_REG_BASE + 0x01C4)
#define A7DA_CLKC_IO_CLK_SEL_STATUS			(_CLKC_REG_BASE + 0x01C8)
#define A7DA_CLKC_G2D_CLK_SEL				(_CLKC_REG_BASE + 0x01CC)
#define A7DA_CLKC_G2D_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01D0)
#define A7DA_CLKC_JPENC_CLK_SEL				(_CLKC_REG_BASE + 0x01D4)
#define A7DA_CLKC_JPENC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01D8)
#define A7DA_CLKC_VDEC_CLK_SEL				(_CLKC_REG_BASE + 0x01DC)
#define A7DA_CLKC_VDEC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01E0)
#define A7DA_CLKC_GMAC_CLK_SEL				(_CLKC_REG_BASE + 0x01E4)
#define A7DA_CLKC_GMAC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01E8)
#define A7DA_CLKC_USB_CLK_SEL				(_CLKC_REG_BASE + 0x01EC)
#define A7DA_CLKC_USB_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01F0)
#define A7DA_CLKC_KAS_CLK_SEL				(_CLKC_REG_BASE + 0x01F4)
#define A7DA_CLKC_KAS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01F8)
#define A7DA_CLKC_SEC_CLK_SEL				(_CLKC_REG_BASE + 0x01FC)
#define A7DA_CLKC_SEC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0200)
#define A7DA_CLKC_SDR_CLK_SEL				(_CLKC_REG_BASE + 0x0204)
#define A7DA_CLKC_SDR_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0208)
#define A7DA_CLKC_VIP_CLK_SEL				(_CLKC_REG_BASE + 0x020C)
#define A7DA_CLKC_VIP_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0210)
#define A7DA_CLKC_NOCD_CLK_SEL				(_CLKC_REG_BASE + 0x0214)
#define A7DA_CLKC_NOCD_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0218)
#define A7DA_CLKC_NOCR_CLK_SEL				(_CLKC_REG_BASE + 0x021C)
#define A7DA_CLKC_NOCR_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0220)
#define A7DA_CLKC_TPIU_CLK_SEL				(_CLKC_REG_BASE + 0x0224)
#define A7DA_CLKC_TPIU_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0228)
#define A7DA_CLKC_HSI2S_CLK_SEL				(_CLKC_REG_BASE + 0x022C)
#define A7DA_CLKC_HSI2S_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0230)
#define A7DA_CLKC_ROOT_CLK_EN0_SET			(_CLKC_REG_BASE + 0x0234)
#define A7DA_CLKC_ROOT_CLK_EN0_CLR			(_CLKC_REG_BASE + 0x0238)
#define A7DA_CLKC_ROOT_CLK_EN0_STATUS		(_CLKC_REG_BASE + 0x023C)
#define A7DA_CLKC_ROOT_CLK_EN1_SET			(_CLKC_REG_BASE + 0x0240)
#define A7DA_CLKC_ROOT_CLK_EN1_CLR			(_CLKC_REG_BASE + 0x0244)
#define A7DA_CLKC_ROOT_CLK_EN1_STATUS		(_CLKC_REG_BASE + 0x0248)
#define A7DA_CLKC_PWM_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x024C)
#define A7DA_CLKC_PWM_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x0250)
#define A7DA_CLKC_PWM_LEAF_CLK_EN_STATUS	(_CLKC_REG_BASE + 0x0254)
#define A7DA_CLKC_MISC1_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x0258)
#define A7DA_CLKC_MISC1_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x025C)
#define A7DA_CLKC_MISC1_LEAF_CLK_EN_STATUS	(_CLKC_REG_BASE + 0x0260)
#define A7DA_CLKC_MISC2_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x0264)
#define A7DA_CLKC_MISC2_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x0268)
#define A7DA_CLKC_MISC2_LEAF_CLK_EN_STATUS	(_CLKC_REG_BASE + 0x026C)
#define A7DA_CLKC_AUDIO_DMAC1_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x0270)
#define A7DA_CLKC_AUDIO_DMAC1_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x0274)
#define A7DA_CLKC_AUDIO_DMAC1_LEAF_CLK_EN_STATUS	(_CLKC_REG_BASE + 0x0278)
#define A7DA_CLKC_AUDIO_DMAC2_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x027C)
#define A7DA_CLKC_AUDIO_DMAC2_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x0280)
#define A7DA_CLKC_AUDIO_DMAC2_LEAF_CLK_EN_STATUS	(_CLKC_REG_BASE + 0x0284)
#define A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x0288)
#define A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x028C)
#define A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_STATUS	(_CLKC_REG_BASE + 0x0290)
#define A7DA_CLKC_DISP_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x0294)
#define A7DA_CLKC_DISP_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x0298)
#define A7DA_CLKC_DISP_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x029C)
#define A7DA_CLKC_GPIO_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x02A0)
#define A7DA_CLKC_GPIO_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x02A4)
#define A7DA_CLKC_GPIO_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02A8)
#define A7DA_CLKC_SDIO01_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x02AC)
#define A7DA_CLKC_SDIO01_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x02B0)
#define A7DA_CLKC_SDIO01_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02B4)
#define A7DA_CLKC_SDIO23_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x02B8)
#define A7DA_CLKC_SDIO23_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x02BC)
#define A7DA_CLKC_SDIO23_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02C0)
#define A7DA_CLKC_SDIO45_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x02C4)
#define A7DA_CLKC_SDIO45_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x02C8)
#define A7DA_CLKC_SDIO45_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02CC)
#define A7DA_CLKC_SDIO67_LEAF_CLK_EN_SET		(_CLKC_REG_BASE + 0x02D0)
#define A7DA_CLKC_SDIO67_LEAF_CLK_EN_CLR		(_CLKC_REG_BASE + 0x02D4)
#define A7DA_CLKC_SDIO67_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02D8)
#define A7DA_CLKC_GNSS_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x02DC)
#define A7DA_CLKC_GNSS_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x02E0)
#define A7DA_CLKC_GNSS_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02E4)
#define A7DA_CLKC_SEC_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x02E8)
#define A7DA_CLKC_SEC_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x02EC)
#define A7DA_CLKC_SEC_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02F0)
#define A7DA_CLKC_DMAC0_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x02F4)
#define A7DA_CLKC_DMAC0_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x02F8)
#define A7DA_CLKC_DMAC0_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x02FC)
#define A7DA_CLKC_CAN1_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x0300)
#define A7DA_CLKC_CAN1_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x0304)
#define A7DA_CLKC_CAN1_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x0308)
#define A7DA_CLKC_ETH_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x030C)
#define A7DA_CLKC_ETH_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x0310)
#define A7DA_CLKC_ETH_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x0314)
#define A7DA_CLKC_MEM_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x0318)
#define A7DA_CLKC_MEM_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x031C)
#define A7DA_CLKC_MEM_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x0320)
#define A7DA_CLKC_CPU_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x0324)
#define A7DA_CLKC_CPU_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x0328)
#define A7DA_CLKC_CPU_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x032C)
#define A7DA_CLKC_GRAPH_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x0330)
#define A7DA_CLKC_GRAPH_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x0334)
#define A7DA_CLKC_GRAPH_LEAF_CLK_EN_STATUS		(_CLKC_REG_BASE + 0x0338)
#define A7DA_CLKC_BT_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x033C)
#define A7DA_CLKC_BT_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x0340)
#define A7DA_CLKC_BT_LEAF_CLK_EN_STATUS			(_CLKC_REG_BASE + 0x0344)
#define A7DA_CLKC_TH_LEAF_CLK_EN_SET			(_CLKC_REG_BASE + 0x0348)
#define A7DA_CLKC_TH_LEAF_CLK_EN_CLR			(_CLKC_REG_BASE + 0x034C)
#define A7DA_CLKC_TH_LEAF_CLK_EN_STATUS			(_CLKC_REG_BASE + 0x0350)
#define A7DA_CLKC_RSTC_PWM_SW_RST_SET			(_CLKC_REG_BASE + 0x0354)
#define A7DA_CLKC_RSTC_PWM_SW_RST_CLR			(_CLKC_REG_BASE + 0x0358)
#define A7DA_CLKC_RSTC_PWM_SW_RST_STATUS		(_CLKC_REG_BASE + 0x035C)
#define A7DA_CLKC_RSTC_MISC1_SW_RST_SET			(_CLKC_REG_BASE + 0x0360)
#define A7DA_CLKC_RSTC_MISC1_SW_RST_CLR			(_CLKC_REG_BASE + 0x0364)
#define A7DA_CLKC_RSTC_MISC1_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0368)
#define A7DA_CLKC_RSTC_MISC2_SW_RST_SET			(_CLKC_REG_BASE + 0x036C)
#define A7DA_CLKC_RSTC_MISC2_SW_RST_CLR			(_CLKC_REG_BASE + 0x0370)
#define A7DA_CLKC_RSTC_MISC2_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0374)
#define A7DA_CLKC_RSTC_AUDIO_DMAC1_SW_RST_SET		(_CLKC_REG_BASE + 0x0378)
#define A7DA_CLKC_RSTC_AUDIO_DMAC1_SW_RST_CLR		(_CLKC_REG_BASE + 0x037C)
#define A7DA_CLKC_RSTC_AUDIO_DMAC1_SW_RST_STATUS	(_CLKC_REG_BASE + 0x0380)
#define A7DA_CLKC_RSTC_AUDIO_DMAC2_SW_RST_SET		(_CLKC_REG_BASE + 0x0384)
#define A7DA_CLKC_RSTC_AUDIO_DMAC2_SW_RST_CLR		(_CLKC_REG_BASE + 0x0388)
#define A7DA_CLKC_RSTC_AUDIO_DMAC2_SW_RST_STATUS	(_CLKC_REG_BASE + 0x038C)
#define A7DA_CLKC_RSTC_AUDIO_DMAC3_SW_RST_SET		(_CLKC_REG_BASE + 0x0390)
#define A7DA_CLKC_RSTC_AUDIO_DMAC3_SW_RST_CLR		(_CLKC_REG_BASE + 0x0394)
#define A7DA_CLKC_RSTC_AUDIO_DMAC3_SW_RST_STATUS	(_CLKC_REG_BASE + 0x0398)
#define A7DA_CLKC_RSTC_DISP_SW_RST_SET			(_CLKC_REG_BASE + 0x039C)
#define A7DA_CLKC_RSTC_DISP_SW_RST_CLR			(_CLKC_REG_BASE + 0x03A0)
#define A7DA_CLKC_RSTC_DISP_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03A4)
#define A7DA_CLKC_RSTC_GPIO_SW_RST_SET			(_CLKC_REG_BASE + 0x03A8)
#define A7DA_CLKC_RSTC_GPIO_SW_RST_CLR			(_CLKC_REG_BASE + 0x03AC)
#define A7DA_CLKC_RSTC_GPIO_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03B0)
#define A7DA_CLKC_RSTC_SDIO01_SW_RST_SET		(_CLKC_REG_BASE + 0x03B4)
#define A7DA_CLKC_RSTC_SDIO01_SW_RST_CLR		(_CLKC_REG_BASE + 0x03B8)
#define A7DA_CLKC_RSTC_SDIO01_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03BC)
#define A7DA_CLKC_RSTC_SDIO23_SW_RST_SET		(_CLKC_REG_BASE + 0x03C0)
#define A7DA_CLKC_RSTC_SDIO23_SW_RST_CLR		(_CLKC_REG_BASE + 0x03C4)
#define A7DA_CLKC_RSTC_SDIO23_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03C8)
#define A7DA_CLKC_RSTC_SDIO45_SW_RST_SET		(_CLKC_REG_BASE + 0x03CC)
#define A7DA_CLKC_RSTC_SDIO45_SW_RST_CLR		(_CLKC_REG_BASE + 0x03D0)
#define A7DA_CLKC_RSTC_SDIO45_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03D4)
#define A7DA_CLKC_RSTC_SDIO67_SW_RST_SET		(_CLKC_REG_BASE + 0x03D8)
#define A7DA_CLKC_RSTC_SDIO67_SW_RST_CLR		(_CLKC_REG_BASE + 0x03DC)
#define A7DA_CLKC_RSTC_SDIO67_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03E0)
#define A7DA_CLKC_RSTC_GNSS_SW_RST_SET			(_CLKC_REG_BASE + 0x03E4)
#define A7DA_CLKC_RSTC_GNSS_SW_RST_CLR			(_CLKC_REG_BASE + 0x03E8)
#define A7DA_CLKC_RSTC_GNSS_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03EC)
#define A7DA_CLKC_RSTC_SEC_SW_RST_SET			(_CLKC_REG_BASE + 0x03F0)
#define A7DA_CLKC_RSTC_SEC_SW_RST_CLR			(_CLKC_REG_BASE + 0x03F4)
#define A7DA_CLKC_RSTC_SEC_SW_RST_STATUS		(_CLKC_REG_BASE + 0x03F8)
#define A7DA_CLKC_RSTC_DMAC0_SW_RST_SET			(_CLKC_REG_BASE + 0x03FC)
#define A7DA_CLKC_RSTC_DMAC0_SW_RST_CLR			(_CLKC_REG_BASE + 0x0400)
#define A7DA_CLKC_RSTC_DMAC0_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0404)
#define A7DA_CLKC_RSTC_CAN1_SW_RST_SET			(_CLKC_REG_BASE + 0x0408)
#define A7DA_CLKC_RSTC_CAN1_SW_RST_CLR			(_CLKC_REG_BASE + 0x040C)
#define A7DA_CLKC_RSTC_CAN1_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0410)
#define A7DA_CLKC_RSTC_ETH_SW_RST_SET			(_CLKC_REG_BASE + 0x0414)
#define A7DA_CLKC_RSTC_ETH_SW_RST_CLR			(_CLKC_REG_BASE + 0x0418)
#define A7DA_CLKC_RSTC_ETH_SW_RST_STATUS		(_CLKC_REG_BASE + 0x041C)
#define A7DA_CLKC_RSTC_MEM_SW_RST_SET			(_CLKC_REG_BASE + 0x0420)
#define A7DA_CLKC_RSTC_MEM_SW_RST_CLR			(_CLKC_REG_BASE + 0x0424)
#define A7DA_CLKC_RSTC_MEM_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0428)
#define A7DA_CLKC_RSTC_CPU_SW_RST_SET			(_CLKC_REG_BASE + 0x042C)
#define A7DA_CLKC_RSTC_CPU_SW_RST_CLR			(_CLKC_REG_BASE + 0x0430)
#define A7DA_CLKC_RSTC_CPU_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0434)
#define A7DA_CLKC_RSTC_GRAPH_SW_RST_SET			(_CLKC_REG_BASE + 0x0438)
#define A7DA_CLKC_RSTC_GRAPH_SW_RST_CLR			(_CLKC_REG_BASE + 0x043C)
#define A7DA_CLKC_RSTC_GRAPH_SW_RST_STATUS		(_CLKC_REG_BASE + 0x0440)
#define A7DA_CLKC_RSTC_BT_SW_RST_SET			(_CLKC_REG_BASE + 0x0444)
#define A7DA_CLKC_RSTC_BT_SW_RST_CLR			(_CLKC_REG_BASE + 0x0448)
#define A7DA_CLKC_RSTC_BT_SW_RST_STATUS			(_CLKC_REG_BASE + 0x044C)
#define A7DA_CLKC_RSTC_TH_SW_RST_SET			(_CLKC_REG_BASE + 0x0450)
#define A7DA_CLKC_RSTC_TH_SW_RST_CLR			(_CLKC_REG_BASE + 0x0454)
#define A7DA_CLKC_RSTC_TH_SW_RST_STATUS			(_CLKC_REG_BASE + 0x0458)
#define A7DA_CLKC_TEST_CLK_SEL				(_CLKC_REG_BASE + 0x045C)
#define A7DA_CLKC_TRG_REFCLK_SEL			(_CLKC_REG_BASE + 0x0460)
#define A7DA_CLKC_CLKC_SW_REG0				(_CLKC_REG_BASE + 0x0464)
#define A7DA_CLKC_CLKC_SW_REG1				(_CLKC_REG_BASE + 0x0468)
#define A7DA_CLKC_CLKC_SW_REG2				(_CLKC_REG_BASE + 0x046C)
#define A7DA_CLKC_CLKC_SW_REG3				(_CLKC_REG_BASE + 0x0470)
#define A7DA_CLKC_CLKC_SW_REG4				(_CLKC_REG_BASE + 0x0474)
#define A7DA_CLKC_CLKC_SW_REG5				(_CLKC_REG_BASE + 0x0478)
#define A7DA_CLKC_NOC_CLK_IDLEREQ_SET			(_CLKC_REG_BASE + 0x047C)
#define A7DA_CLKC_NOC_CLK_IDLEREQ_CLEAR			(_CLKC_REG_BASE + 0x0480)
#define A7DA_CLKC_NOC_CLK_IDLEREQ_STATUS		(_CLKC_REG_BASE + 0x0484)
#define A7DA_CLKC_PLUG_CLK_IDLEREQ_SET			(_CLKC_REG_BASE + 0x0488)
#define A7DA_CLKC_PLUG_CLK_IDLEREQ_CLEAR		(_CLKC_REG_BASE + 0x048C)
#define A7DA_CLKC_PLUG_CLK_IDLEREQ_STATUS		(_CLKC_REG_BASE + 0x0490)
#define A7DA_CLKC_NOC_CLK_SLVRDY_SET			(_CLKC_REG_BASE + 0x0494)
#define A7DA_CLKC_NOC_CLK_SLVRDY_CLEAR			(_CLKC_REG_BASE + 0x0498)
#define A7DA_CLKC_NOC_CLK_SLVRDY_STATUS			(_CLKC_REG_BASE + 0x049C)
#define A7DA_CLKC_NOC_CLK_IDLE_STATUS			(_CLKC_REG_BASE + 0x04A0)
#define A7DA_CLKC_PLUG_CLK_IDLE_STATUS			(_CLKC_REG_BASE + 0x04A4)
#define A7DA_CLKC_NOC_CLK_IDLEACK_STATUS		(_CLKC_REG_BASE + 0x04A8)
#define A7DA_CLKC_PLUG_CLK_IDLEACK_STATUS		(_CLKC_REG_BASE + 0x04AC)
#define A7DA_CLKC_NOC_SOCKETCONN_STATUS			(_CLKC_REG_BASE + 0x04B0)
#define A7DA_CLKC_RSTC_A7_SW_RST			(_CLKC_REG_BASE + 0x04B4)
#define A7DA_CLKC_RSTC_A7_DBG_RST			(_CLKC_REG_BASE + 0x04B8)
#define A7DA_CLKC_RSTC_SREFRESH_EN			(_CLKC_REG_BASE + 0x04BC)
#define A7DA_CLKC_RSTC_STATUS				(_CLKC_REG_BASE + 0x04C0)
#define A7DA_CLKC_RSTC_STATUS_CLR			(_CLKC_REG_BASE + 0x04C4)
#define A7DA_CLKC_RSTC_STATUS_SET			(_CLKC_REG_BASE + 0x04C8)
#define A7DA_CLKC_RSTC_MEMC_ACK_TIMER			(_CLKC_REG_BASE + 0x04CC)
#define A7DA_CLKC_RSTC_DRAM_HOLD_TIMER			(_CLKC_REG_BASE + 0x04D0)
#define A7DA_CLKC_AUDIO_AFE_CVD_VIP0_FLUSH		(_CLKC_REG_BASE + 0x0500)
#define A7DA_CLKC_DCU_FLUSH					(_CLKC_REG_BASE + 0x0504)
#define A7DA_CLKC_DMAC0_FLUSH				(_CLKC_REG_BASE + 0x0508)
#define A7DA_CLKC_DMAC1_FLUSH				(_CLKC_REG_BASE + 0x050C)
#define A7DA_CLKC_DMAC2_FLUSH				(_CLKC_REG_BASE + 0x0510)
#define A7DA_CLKC_DMAC3_FLUSH				(_CLKC_REG_BASE + 0x0514)
#define A7DA_CLKC_DMAC4_FLUSH				(_CLKC_REG_BASE + 0x0518)
#define A7DA_CLKC_ETH_AVB_FLUSH				(_CLKC_REG_BASE + 0x051C)
#define A7DA_CLKC_G2D_FLUSH					(_CLKC_REG_BASE + 0x0520)
#define A7DA_CLKC_JPEG_FLUSH				(_CLKC_REG_BASE + 0x0524)
#define A7DA_CLKC_KAS_AXI_I_FLUSH			(_CLKC_REG_BASE + 0x0528)
#define A7DA_CLKC_LCD0_FLUSH				(_CLKC_REG_BASE + 0x052C)
#define A7DA_CLKC_LCD1_FLUSH				(_CLKC_REG_BASE + 0x0530)
#define A7DA_CLKC_MEDIAM_SYS2PCI_FLUSH		(_CLKC_REG_BASE + 0x0534)
#define A7DA_CLKC_NAND_FLUSH				(_CLKC_REG_BASE + 0x0538)
#define A7DA_CLKC_SDR_FLUSH					(_CLKC_REG_BASE + 0x053C)
#define A7DA_CLKC_SGX_FLUSH					(_CLKC_REG_BASE + 0x0540)
#define A7DA_CLKC_SYS2PCI_FLUSH				(_CLKC_REG_BASE + 0x0544)
#define A7DA_CLKC_USB0_FLUSH				(_CLKC_REG_BASE + 0x0548)
#define A7DA_CLKC_USB1_FLUSH				(_CLKC_REG_BASE + 0x054C)
#define A7DA_CLKC_USP0_AXI_I_FLUSH			(_CLKC_REG_BASE + 0x0550)
#define A7DA_CLKC_VIP1_FLUSH				(_CLKC_REG_BASE + 0x0554)
#define A7DA_CLKC_VPP0_FLUSH				(_CLKC_REG_BASE + 0x0558)
#define A7DA_CLKC_VPP1_FLUSH				(_CLKC_REG_BASE + 0x055C)
#define A7DA_CLKC_VXD_FLUSH					(_CLKC_REG_BASE + 0x0560)
#define A7DA_CLKC_DDR_BIST_FLUSH			(_CLKC_REG_BASE + 0x0564)
#define A7DA_CLKC_PWRC_BCRL_VAL				(_CLKC_REG_BASE + 0x0568)

#else

#define A7DA_CLKC_MEMPLL_AB_FREQ		(_CLKC_REG_BASE + 0x0000)
#define A7DA_CLKC_MEMPLL_AB_SSC			(_CLKC_REG_BASE + 0x0004)
#define A7DA_CLKC_MEMPLL_AB_CTRL0		(_CLKC_REG_BASE + 0x0008)
#define A7DA_CLKC_MEMPLL_AB_CTRL1		(_CLKC_REG_BASE + 0x000C)
#define A7DA_CLKC_MEMPLL_AB_STATUS		(_CLKC_REG_BASE + 0x0010)
#define A7DA_CLKC_MEMPLL_AB_SSRAM_ADDR		(_CLKC_REG_BASE + 0x0014)
#define A7DA_CLKC_MEMPLL_AB_SSRAM_DATA		(_CLKC_REG_BASE + 0x0018)
#define A7DA_CLKC_CPUPLL_AB_FREQ		(_CLKC_REG_BASE + 0x001C)
#define A7DA_CLKC_CPUPLL_AB_SSC			(_CLKC_REG_BASE + 0x0020)
#define A7DA_CLKC_CPUPLL_AB_CTRL0		(_CLKC_REG_BASE + 0x0024)
#define A7DA_CLKC_CPUPLL_AB_CTRL1		(_CLKC_REG_BASE + 0x0028)
#define A7DA_CLKC_CPUPLL_AB_STATUS		(_CLKC_REG_BASE + 0x002C)
#define A7DA_CLKC_SYS0_BTPLL_AB_FREQ		(_CLKC_REG_BASE + 0x0030)
#define A7DA_CLKC_SYS0_BTPLL_AB_SSC		(_CLKC_REG_BASE + 0x0034)
#define A7DA_CLKC_SYS0_BTPLL_AB_CTRL0		(_CLKC_REG_BASE + 0x0038)
#define A7DA_CLKC_SYS0_BTPLL_AB_CTRL1		(_CLKC_REG_BASE + 0x003C)
#define A7DA_CLKC_SYS0_BTPLL_AB_STATUS		(_CLKC_REG_BASE + 0x0040)
#define A7DA_CLKC_SYS1_USBPLL_AB_FREQ		(_CLKC_REG_BASE + 0x0044)
#define A7DA_CLKC_SYS1_USBPLL_AB_SSC		(_CLKC_REG_BASE + 0x0048)
#define A7DA_CLKC_SYS1_USBPLL_AB_CTRL0		(_CLKC_REG_BASE + 0x004C)
#define A7DA_CLKC_SYS1_USBPLL_AB_CTRL1		(_CLKC_REG_BASE + 0x0050)
#define A7DA_CLKC_SYS1_USBPLL_AB_STATUS		(_CLKC_REG_BASE + 0x0054)
#define A7DA_CLKC_SYS2_ETHPLL_AB_FREQ		(_CLKC_REG_BASE + 0x0058)
#define A7DA_CLKC_SYS2_ETHPLL_AB_SSC		(_CLKC_REG_BASE + 0x005C)
#define A7DA_CLKC_SYS2_ETHPLL_AB_CTRL0		(_CLKC_REG_BASE + 0x0060)
#define A7DA_CLKC_SYS2_ETHPLL_AB_CTRL1		(_CLKC_REG_BASE + 0x0064)
#define A7DA_CLKC_SYS2_ETHPLL_AB_STATUS		(_CLKC_REG_BASE + 0x0068)
#define A7DA_CLKC_SYS3_SSCPLL_AB_FREQ		(_CLKC_REG_BASE + 0x006C)
#define A7DA_CLKC_SYS3_SSCPLL_AB_SSC		(_CLKC_REG_BASE + 0x0070)
#define A7DA_CLKC_SYS3_SSCPLL_AB_CTRL0		(_CLKC_REG_BASE + 0x0074)
#define A7DA_CLKC_SYS3_SSCPLL_AB_CTRL1		(_CLKC_REG_BASE + 0x0078)
#define A7DA_CLKC_SYS3_SSCPLL_AB_STATUS		(_CLKC_REG_BASE + 0x007C)
#define A7DA_CLKC_SYS3_SSCPLL_AB_SSRAM_ADDR	(_CLKC_REG_BASE + 0x0080)
#define A7DA_CLKC_SYS3_SSCPLL_AB_SSRAM_DATA	(_CLKC_REG_BASE + 0x0084)
#define A7DA_CLKC_AUDIO_DTO_INC			(_CLKC_REG_BASE + 0x0088)
#define A7DA_CLKC_DISP0_DTO_INC			(_CLKC_REG_BASE + 0x008C)
#define A7DA_CLKC_DISP1_DTO_INC			(_CLKC_REG_BASE + 0x0090)
#define A7DA_CLKC_AUDIO_DTO_SRC			(_CLKC_REG_BASE + 0x0094)
#define A7DA_CLKC_AUDIO_DTO_ENA			(_CLKC_REG_BASE + 0x0098)
#define A7DA_CLKC_AUDIO_DTO_DROFF		(_CLKC_REG_BASE + 0x009C)
#define A7DA_CLKC_DISP0_DTO_SRC			(_CLKC_REG_BASE + 0x00A0)
#define A7DA_CLKC_DISP0_DTO_ENA			(_CLKC_REG_BASE + 0x00A4)
#define A7DA_CLKC_DISP0_DTO_DROFF		(_CLKC_REG_BASE + 0x00A8)
#define A7DA_CLKC_DISP1_DTO_SRC			(_CLKC_REG_BASE + 0x00AC)
#define A7DA_CLKC_DISP1_DTO_ENA			(_CLKC_REG_BASE + 0x00B0)
#define A7DA_CLKC_DISP1_DTO_DROFF		(_CLKC_REG_BASE + 0x00B4)
#define A7DA_CLKC_I2S_CLK_SEL			(_CLKC_REG_BASE + 0x00B8)
#define A7DA_CLKC_I2S_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00BC)
#define A7DA_CLKC_USBPHY_CLK_CFG		(_CLKC_REG_BASE + 0x00C0)
#define A7DA_CLKC_USBPHY_CLK_DIVENA		(_CLKC_REG_BASE + 0x00C4)
#define A7DA_CLKC_USBPHY_CLK_SEL		(_CLKC_REG_BASE + 0x00C8)
#define A7DA_CLKC_USBPHY_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00CC)
#define A7DA_CLKC_BTSS_CLK_CFG			(_CLKC_REG_BASE + 0x00D0)
#define A7DA_CLKC_BTSS_CLK_DIVENA		(_CLKC_REG_BASE + 0x00D4)
#define A7DA_CLKC_BTSS_CLK_SEL			(_CLKC_REG_BASE + 0x00D8)
#define A7DA_CLKC_BTSS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00DC)
#define A7DA_CLKC_RGMII_CLK_CFG			(_CLKC_REG_BASE + 0x00E0)
#define A7DA_CLKC_RGMII_CLK_DIVENA		(_CLKC_REG_BASE + 0x00E4)
#define A7DA_CLKC_RGMII_CLK_SEL			(_CLKC_REG_BASE + 0x00E8)
#define A7DA_CLKC_RGMII_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00EC)
#define A7DA_CLKC_CPU_CLK_CFG			(_CLKC_REG_BASE + 0x00F0)
#define A7DA_CLKC_CPU_CLK_DIVENA		(_CLKC_REG_BASE + 0x00F4)
#define A7DA_CLKC_CPU_CLK_SEL			(_CLKC_REG_BASE + 0x00F8)
#define A7DA_CLKC_CPU_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x00FC)
#define A7DA_CLKC_SDPHY01_CLK_CFG		(_CLKC_REG_BASE + 0x0100)
#define A7DA_CLKC_SDPHY01_CLK_DIVENA		(_CLKC_REG_BASE + 0x0104)
#define A7DA_CLKC_SDPHY01_CLK_SEL		(_CLKC_REG_BASE + 0x0108)
#define A7DA_CLKC_SDPHY01_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x010C)
#define A7DA_CLKC_SDPHY23_CLK_CFG		(_CLKC_REG_BASE + 0x0110)
#define A7DA_CLKC_SDPHY23_CLK_DIVENA		(_CLKC_REG_BASE + 0x0114)
#define A7DA_CLKC_SDPHY23_CLK_SEL		(_CLKC_REG_BASE + 0x0118)
#define A7DA_CLKC_SDPHY23_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x011C)
#define A7DA_CLKC_SDPHY45_CLK_CFG		(_CLKC_REG_BASE + 0x0120)
#define A7DA_CLKC_SDPHY45_CLK_DIVENA		(_CLKC_REG_BASE + 0x0124)
#define A7DA_CLKC_SDPHY45_CLK_SEL		(_CLKC_REG_BASE + 0x0128)
#define A7DA_CLKC_SDPHY45_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x012C)
#define A7DA_CLKC_SDPHY67_CLK_CFG		(_CLKC_REG_BASE + 0x0130)
#define A7DA_CLKC_SDPHY67_CLK_DIVENA		(_CLKC_REG_BASE + 0x0134)
#define A7DA_CLKC_SDPHY67_CLK_SEL		(_CLKC_REG_BASE + 0x0138)
#define A7DA_CLKC_SDPHY67_CLK_SEL_STATUS	(_CLKC_REG_BASE + 0x013C)
#define A7DA_CLKC_CAN_CLK_CFG			(_CLKC_REG_BASE + 0x0140)
#define A7DA_CLKC_CAN_CLK_DIVENA		(_CLKC_REG_BASE + 0x0144)
#define A7DA_CLKC_CAN_CLK_SEL			(_CLKC_REG_BASE + 0x0148)
#define A7DA_CLKC_CAN_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x014C)
#define A7DA_CLKC_DEINT_CLK_CFG			(_CLKC_REG_BASE + 0x0150)
#define A7DA_CLKC_DEINT_CLK_DIVENA		(_CLKC_REG_BASE + 0x0154)
#define A7DA_CLKC_DEINT_CLK_SEL			(_CLKC_REG_BASE + 0x0158)
#define A7DA_CLKC_DEINT_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x015C)
#define A7DA_CLKC_NAND_CLK_CFG			(_CLKC_REG_BASE + 0x0160)
#define A7DA_CLKC_NAND_CLK_DIVENA		(_CLKC_REG_BASE + 0x0164)
#define A7DA_CLKC_NAND_CLK_SEL			(_CLKC_REG_BASE + 0x0168)
#define A7DA_CLKC_NAND_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x016C)
#define A7DA_CLKC_DISP0_CLK_CFG			(_CLKC_REG_BASE + 0x0170)
#define A7DA_CLKC_DISP0_CLK_DIVENA		(_CLKC_REG_BASE + 0x0174)
#define A7DA_CLKC_DISP0_CLK_SEL			(_CLKC_REG_BASE + 0x0178)
#define A7DA_CLKC_DISP0_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x017C)
#define A7DA_CLKC_DISP1_CLK_CFG			(_CLKC_REG_BASE + 0x0180)
#define A7DA_CLKC_DISP1_CLK_DIVENA		(_CLKC_REG_BASE + 0x0184)
#define A7DA_CLKC_DISP1_CLK_SEL			(_CLKC_REG_BASE + 0x0188)
#define A7DA_CLKC_DISP1_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x018C)
#define A7DA_CLKC_GPU_CLK_CFG			(_CLKC_REG_BASE + 0x0190)
#define A7DA_CLKC_GPU_CLK_DIVENA		(_CLKC_REG_BASE + 0x0194)
#define A7DA_CLKC_GPU_CLK_SEL			(_CLKC_REG_BASE + 0x0198)
#define A7DA_CLKC_GPU_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x019C)
#define A7DA_CLKC_GNSS_CLK_CFG			(_CLKC_REG_BASE + 0x01A0)
#define A7DA_CLKC_GNSS_CLK_DIVENA		(_CLKC_REG_BASE + 0x01A4)
#define A7DA_CLKC_GNSS_CLK_SEL			(_CLKC_REG_BASE + 0x01A8)
#define A7DA_CLKC_GNSS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01AC)
#define A7DA_CLKC_SHARED_DIVIDERS_CFG0		(_CLKC_REG_BASE + 0x01B0)
#define A7DA_CLKC_SHARED_DIVIDERS_CFG1		(_CLKC_REG_BASE + 0x01B4)
#define A7DA_CLKC_SHARED_DIVIDERS_ENA		(_CLKC_REG_BASE + 0x01B8)
#define A7DA_CLKC_SYS_CLK_SEL			(_CLKC_REG_BASE + 0x01BC)
#define A7DA_CLKC_SYS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01C0)
#define A7DA_CLKC_IO_CLK_SEL			(_CLKC_REG_BASE + 0x01C4)
#define A7DA_CLKC_IO_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01C8)
#define A7DA_CLKC_G2D_CLK_SEL			(_CLKC_REG_BASE + 0x01CC)
#define A7DA_CLKC_G2D_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01D0)
#define A7DA_CLKC_JPENC_CLK_SEL			(_CLKC_REG_BASE + 0x01D4)
#define A7DA_CLKC_JPENC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01D8)
#define A7DA_CLKC_VDEC_CLK_SEL			(_CLKC_REG_BASE + 0x01DC)
#define A7DA_CLKC_VDEC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01E0)
#define A7DA_CLKC_GMAC_CLK_SEL			(_CLKC_REG_BASE + 0x01E4)
#define A7DA_CLKC_GMAC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01E8)
#define A7DA_CLKC_USB_CLK_SEL			(_CLKC_REG_BASE + 0x01EC)
#define A7DA_CLKC_USB_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01F0)
#define A7DA_CLKC_KAS_CLK_SEL			(_CLKC_REG_BASE + 0x01F4)
#define A7DA_CLKC_KAS_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x01F8)
#define A7DA_CLKC_SEC_CLK_SEL			(_CLKC_REG_BASE + 0x01FC)
#define A7DA_CLKC_SEC_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0200)
#define A7DA_CLKC_SDR_CLK_SEL			(_CLKC_REG_BASE + 0x0204)
#define A7DA_CLKC_SDR_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0208)
#define A7DA_CLKC_VIP_CLK_SEL			(_CLKC_REG_BASE + 0x020C)
#define A7DA_CLKC_VIP_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0210)
#define A7DA_CLKC_NOCD_CLK_SEL			(_CLKC_REG_BASE + 0x0214)
#define A7DA_CLKC_NOCD_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0218)
#define A7DA_CLKC_NOCR_CLK_SEL			(_CLKC_REG_BASE + 0x021C)
#define A7DA_CLKC_NOCR_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0220)
#define A7DA_CLKC_TPIU_CLK_SEL			(_CLKC_REG_BASE + 0x0224)
#define A7DA_CLKC_TPIU_CLK_SEL_STATUS		(_CLKC_REG_BASE + 0x0228)
#define A7DA_CLKC_ROOT_CLK_EN0_SET		(_CLKC_REG_BASE + 0x022C)
#define A7DA_CLKC_ROOT_CLK_EN0_CLR		(_CLKC_REG_BASE + 0x0230)
#define A7DA_CLKC_ROOT_CLK_EN0_STATUS		(_CLKC_REG_BASE + 0x0234)
#define A7DA_CLKC_ROOT_CLK_EN1_SET		(_CLKC_REG_BASE + 0x0238)
#define A7DA_CLKC_ROOT_CLK_EN1_CLR		(_CLKC_REG_BASE + 0x023C)
#define A7DA_CLKC_ROOT_CLK_EN1_STATUS		(_CLKC_REG_BASE + 0x0240)
#define A7DA_CLKC_LEAF_CLK_EN0_SET		(_CLKC_REG_BASE + 0x0244)
#define A7DA_CLKC_LEAF_CLK_EN0_CLR		(_CLKC_REG_BASE + 0x0248)
#define A7DA_CLKC_LEAF_CLK_EN0_STATUS		(_CLKC_REG_BASE + 0x024C)
#define A7DA_CLKC_TEST_CLK_SEL			(_CLKC_REG_BASE + 0x02B0)
#define A7DA_CLKC_TRG_REFCLK_SEL		(_CLKC_REG_BASE + 0x02B4)
#define A7DA_CLKC_CLKC_SW_REG0			(_CLKC_REG_BASE + 0x02B8)
#define A7DA_CLKC_CLKC_SW_REG1			(_CLKC_REG_BASE + 0x02BC)
#define A7DA_CLKC_CLKC_SW_REG2			(_CLKC_REG_BASE + 0x02C0)
#define A7DA_CLKC_CLKC_SW_REG3			(_CLKC_REG_BASE + 0x02C4)
#define A7DA_CLKC_CLKC_SW_REG4			(_CLKC_REG_BASE + 0x02C8)
#define A7DA_CLKC_CLKC_SW_REG5			(_CLKC_REG_BASE + 0x02CC)
#define A7DA_CLKC_NOC_CLK_IDLEREQ_SET		(_CLKC_REG_BASE + 0x02D0)
#define A7DA_CLKC_NOC_CLK_IDLEREQ_CLEAR		(_CLKC_REG_BASE + 0x02D4)
#define A7DA_CLKC_NOC_CLK_IDLEREQ_STATUS	(_CLKC_REG_BASE + 0x02D8)
#define A7DA_CLKC_PLUG_CLK_IDLEREQ_SET		(_CLKC_REG_BASE + 0x02DC)
#define A7DA_CLKC_PLUG_CLK_IDLEREQ_CLEAR	(_CLKC_REG_BASE + 0x02E0)
#define A7DA_CLKC_PLUG_CLK_IDLEREQ_STATUS	(_CLKC_REG_BASE + 0x02E4)
#define A7DA_CLKC_NOC_CLK_SLVRDY_SET		(_CLKC_REG_BASE + 0x02E8)
#define A7DA_CLKC_NOC_CLK_SLVRDY_CLEAR		(_CLKC_REG_BASE + 0x02EC)
#define A7DA_CLKC_NOC_CLK_SLVRDY_STATUS		(_CLKC_REG_BASE + 0x02F0)
#define A7DA_CLKC_NOC_CLK_IDLE_STATUS		(_CLKC_REG_BASE + 0x02F4)
#define A7DA_CLKC_PLUG_CLK_IDLE_STATUS		(_CLKC_REG_BASE + 0x02F8)
#define A7DA_CLKC_NOC_CLK_IDLEACK_STATUS	(_CLKC_REG_BASE + 0x02FC)
#define A7DA_CLKC_PLUG_CLK_IDLEACK_STATUS	(_CLKC_REG_BASE + 0x0300)
#define A7DA_CLKC_NOC_SOCKETCONN_STATUS		(_CLKC_REG_BASE + 0x0304)
#define A7DA_CLKC_RSTC_A7_SW_RST		(_CLKC_REG_BASE + 0x0308)
#define A7DA_CLKC_RSTC_A7_DBG_RST		(_CLKC_REG_BASE + 0x030C)
#define A7DA_CLKC_RSTC_SREFRESN_EN		(_CLKC_REG_BASE + 0x0310)
#define A7DA_CLKC_RSTC_STATUS			(_CLKC_REG_BASE + 0x0314)
#define A7DA_CLKC_RSTC_STATUS_CLR		(_CLKC_REG_BASE + 0x0318)
#define A7DA_CLKC_RSTC_TIMER			(_CLKC_REG_BASE + 0x031C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST0_SET		(_CLKC_REG_BASE + 0x0320)
#define A7DA_CLKC_RSTC_UNIT_SW_RST0_CLR		(_CLKC_REG_BASE + 0x0324)
#define A7DA_CLKC_RSTC_UNIT_SW_RST0_STATUS	(_CLKC_REG_BASE + 0x0328)
#define A7DA_CLKC_RSTC_UNIT_SW_RST1_SET		(_CLKC_REG_BASE + 0x032C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST1_CLR		(_CLKC_REG_BASE + 0x0330)
#define A7DA_CLKC_RSTC_UNIT_SW_RST1_STATUS	(_CLKC_REG_BASE + 0x0334)
#define A7DA_CLKC_RSTC_UNIT_SW_RST2_SET		(_CLKC_REG_BASE + 0x0338)
#define A7DA_CLKC_RSTC_UNIT_SW_RST2_CLR		(_CLKC_REG_BASE + 0x033C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST2_STATUS	(_CLKC_REG_BASE + 0x0340)
#define A7DA_CLKC_RSTC_UNIT_SW_RST3_SET		(_CLKC_REG_BASE + 0x0344)
#define A7DA_CLKC_RSTC_UNIT_SW_RST3_CLR		(_CLKC_REG_BASE + 0x0348)
#define A7DA_CLKC_RSTC_UNIT_SW_RST3_STATUS	(_CLKC_REG_BASE + 0x034C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST4_SET		(_CLKC_REG_BASE + 0x0350)
#define A7DA_CLKC_RSTC_UNIT_SW_RST4_CLR		(_CLKC_REG_BASE + 0x0354)
#define A7DA_CLKC_RSTC_UNIT_SW_RST4_STATUS	(_CLKC_REG_BASE + 0x0358)
#define A7DA_CLKC_RSTC_UNIT_SW_RST5_SET		(_CLKC_REG_BASE + 0x035C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST5_CLR		(_CLKC_REG_BASE + 0x0360)
#define A7DA_CLKC_RSTC_UNIT_SW_RST5_STATUS	(_CLKC_REG_BASE + 0x0364)
#define A7DA_CLKC_RSTC_UNIT_SW_RST6_SET		(_CLKC_REG_BASE + 0x0368)
#define A7DA_CLKC_RSTC_UNIT_SW_RST6_CLR		(_CLKC_REG_BASE + 0x036C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST6_STATUS	(_CLKC_REG_BASE + 0x0370)
#define A7DA_CLKC_RSTC_UNIT_SW_RST7_SET		(_CLKC_REG_BASE + 0x0374)
#define A7DA_CLKC_RSTC_UNIT_SW_RST7_CLR		(_CLKC_REG_BASE + 0x0378)
#define A7DA_CLKC_RSTC_UNIT_SW_RST7_STATUS	(_CLKC_REG_BASE + 0x037C)
#define A7DA_CLKC_RSTC_UNIT_SW_RST8_SET		(_CLKC_REG_BASE + 0x0380)
#define A7DA_CLKC_RSTC_UNIT_SW_RST8_CLR		(_CLKC_REG_BASE + 0x0384)
#define A7DA_CLKC_RSTC_UNIT_SW_RST8_STATUS	(_CLKC_REG_BASE + 0x0388)
#define A7DA_CLKC_LEAF_CLK_EN1_SET		(_CLKC_REG_BASE + 0x04A0)
#define A7DA_CLKC_LEAF_CLK_EN1_CLR		(_CLKC_REG_BASE + 0x04A4)
#define A7DA_CLKC_LEAF_CLK_EN1_STATUS		(_CLKC_REG_BASE + 0x04A8)
#define A7DA_CLKC_LEAF_CLK_EN2_SET		(_CLKC_REG_BASE + 0x04B8)
#define A7DA_CLKC_LEAF_CLK_EN2_CLR		(_CLKC_REG_BASE + 0x04BC)
#define A7DA_CLKC_LEAF_CLK_EN2_STATUS		(_CLKC_REG_BASE + 0x04C0)
#define A7DA_CLKC_LEAF_CLK_EN3_SET		(_CLKC_REG_BASE + 0x04D0)
#define A7DA_CLKC_LEAF_CLK_EN3_CLR		(_CLKC_REG_BASE + 0x04D4)
#define A7DA_CLKC_LEAF_CLK_EN3_STATUS		(_CLKC_REG_BASE + 0x04D8)
#define A7DA_CLKC_LEAF_CLK_EN4_SET		(_CLKC_REG_BASE + 0x04E8)
#define A7DA_CLKC_LEAF_CLK_EN4_CLR		(_CLKC_REG_BASE + 0x04EC)
#define A7DA_CLKC_LEAF_CLK_EN4_STATUS		(_CLKC_REG_BASE + 0x04F0)
#define A7DA_CLKC_LEAF_CLK_EN5_SET		(_CLKC_REG_BASE + 0x0500)
#define A7DA_CLKC_LEAF_CLK_EN5_CLR		(_CLKC_REG_BASE + 0x0504)
#define A7DA_CLKC_LEAF_CLK_EN5_STATUS		(_CLKC_REG_BASE + 0x0508)
#define A7DA_CLKC_LEAF_CLK_EN6_SET		(_CLKC_REG_BASE + 0x0518)
#define A7DA_CLKC_LEAF_CLK_EN6_CLR		(_CLKC_REG_BASE + 0x051C)
#define A7DA_CLKC_LEAF_CLK_EN6_STATUS		(_CLKC_REG_BASE + 0x0520)
#define A7DA_CLKC_LEAF_CLK_EN7_SET		(_CLKC_REG_BASE + 0x0530)
#define A7DA_CLKC_LEAF_CLK_EN7_CLR		(_CLKC_REG_BASE + 0x0534)
#define A7DA_CLKC_LEAF_CLK_EN7_STATUS		(_CLKC_REG_BASE + 0x0538)
#define A7DA_CLKC_LEAF_CLK_EN8_SET		(_CLKC_REG_BASE + 0x0548)
#define A7DA_CLKC_LEAF_CLK_EN8_CLR		(_CLKC_REG_BASE + 0x054C)
#define A7DA_CLKC_LEAF_CLK_EN8_STATUS		(_CLKC_REG_BASE + 0x0550)

#endif

static inline void clkc_enable_usp0(void)
{
	SOC_REG(A7DA_CLKC_AUDIO_DMAC2_LEAF_CLK_EN_SET) = BIT1;
}

static inline void clkc_enable_usp1(void)
{
	SOC_REG(A7DA_CLKC_AUDIO_DMAC2_LEAF_CLK_EN_SET) = BIT2;
}

static inline void clkc_enable_usp2(void)
{
	SOC_REG(A7DA_CLKC_AUDIO_DMAC2_LEAF_CLK_EN_SET) = BIT3;
}

static inline void clkc_enable_usp3(void)
{
	SOC_REG(A7DA_CLKC_BT_LEAF_CLK_EN_SET) = BIT1 | BIT4 | BIT5;
}

/* I2S Clock enable */
static inline void clkc_enable_i2s(void)
{
	/* Set the clk's source as DTO */

	REG_UPDATE_BITS(A7DA_CLKC_AUDIO_DTO_ENA, BIT0, BIT0);
	SOC_REG(A7DA_CLKC_I2S_CLK_SEL) = 0x2;
	SOC_REG(A7DA_CLKC_ROOT_CLK_EN0_SET) = BIT8;
	SOC_REG(A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_SET) = BIT3 | BIT4;
}

/* I2C0 Clock enable */
static inline void clkc_enable_i2c0(void)
{
	SOC_REG(A7DA_CLKC_ROOT_CLK_EN0_SET) = BIT14;
	SOC_REG(A7DA_CLKC_IO_CLK_SEL) = 0x3;
	SOC_REG(A7DA_CLKC_MISC2_LEAF_CLK_EN_SET) = BIT0;
}

/* I2C0 Clock enable */
static inline void clkc_enable_i2c1(void)
{
	SOC_REG(A7DA_CLKC_ROOT_CLK_EN0_SET) = BIT14;
	SOC_REG(A7DA_CLKC_IO_CLK_SEL) = 0x3;
	SOC_REG(A7DA_CLKC_MISC2_LEAF_CLK_EN_SET) = BIT1;
}

static inline void clkc_disable_i2c0(void)
{
	SOC_REG(A7DA_CLKC_MISC2_LEAF_CLK_EN_CLR) = BIT0;
}

static inline void clkc_disable_i2c1(void)
{
	SOC_REG(A7DA_CLKC_MISC2_LEAF_CLK_EN_CLR) = BIT1;
}

/* IACC clock enable */
static inline void clkc_enable_iacc(void)
{
	SOC_REG(A7DA_CLKC_ROOT_CLK_EN0_SET) = BIT0;
	SOC_REG(A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_SET) = BIT3;
}

/* enable Kalimba clock */
static inline void clkc_enable_kalimba(void)
{
		SOC_REG(A7DA_CLKC_ROOT_CLK_EN1_SET) = BIT3 | BIT9;
#ifdef __ATLAS7_STEP_B__
		SOC_REG(A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_SET) = BIT2;
#else
		SOC_REG(A7DA_CLKC_LEAF_CLK_EN1_SET) = BIT8;
#endif
}

/* Set DDRM to idle state */
static inline void clkc_set_ddrm_idle(void)
{
		SOC_REG(A7DA_CLKC_PLUG_CLK_IDLEREQ_SET) = (BIT2 | BIT3 | BIT4 |
						BIT5 | BIT6);
}

/* IPC need this clk */
static inline void clkc_enable_vdifm_nocr(void)
{
		SOC_REG(A7DA_CLKC_ROOT_CLK_EN1_SET) = BIT12;
}

/* OTP&UART need this clk */
static inline void clkc_enable_gnssm_io(void)
{
		SOC_REG(A7DA_CLKC_ROOT_CLK_EN0_SET) = BIT13;
}

/* IOCTOP & TIMER need this clk */
static inline void clkc_enable_audmscm_io(void)
{
		SOC_REG(A7DA_CLKC_ROOT_CLK_EN0_SET) = BIT11;
}

/* enable atlas7 ioctop clk, enable audmscm_io first */
static inline void clkc_enable_ioc_top_io(void)
{
#ifdef __ATLAS7_STEP_B__
		SOC_REG(A7DA_CLKC_MISC2_LEAF_CLK_EN_SET) = BIT5;
#else
		SOC_REG(A7DA_CLKC_LEAF_CLK_EN1_SET) = BIT4;
#endif
}

/* enable atlas7 timer clk, enable audmscm_io first */
static inline void clkc_enable_timer_io(void)
{
#ifdef __ATLAS7_STEP_B__
		SOC_REG(A7DA_CLKC_MISC1_LEAF_CLK_EN_SET) = BIT0;
#else
		SOC_REG(A7DA_CLKC_LEAF_CLK_EN1_SET) = BIT1;
#endif
}

/* enable atlas7 uart0 clk, enable gnssm_io first */
static inline void clkc_enable_uart_io(void)
{
#ifdef __ATLAS7_STEP_B__
		SOC_REG(A7DA_CLKC_DMAC0_LEAF_CLK_EN_SET) = BIT1;
#else
		SOC_REG(A7DA_CLKC_LEAF_CLK_EN3_SET) = BIT4;
#endif
}

/* enable can bus 1 clk */
static inline void clkc_enable_canbus1_io(void)
{
#ifdef __ATLAS7_STEP_B__
		SOC_REG(A7DA_CLKC_CAN1_LEAF_CLK_EN_SET) = BIT0;
		SOC_REG(A7DA_CLKC_DMAC0_LEAF_CLK_EN_SET) = BIT1;
#else
		SOC_REG(A7DA_CLKC_ROOT_CLK_EN1_SET) = BIT26;
		SOC_REG(A7DA_CLKC_LEAF_CLK_EN3_SET) = BIT12;
#endif
}

/* enable TSADC clock */
static inline void clkc_enable_tsadc(void)
{
#ifdef __ATLAS7_STEP_B__
		SOC_REG(A7DA_CLKC_MISC2_LEAF_CLK_EN_SET) = BIT2 | BIT3;
		SOC_REG(A7DA_CLKC_AUDIO_DMAC3_LEAF_CLK_EN_SET) = BIT5;
#else
		SOC_REG(A7DA_CLKC_LEAF_CLK_EN1_SET) = BIT3 | BIT21;
#endif
}

/* set m3 wake up flags */
static inline void clkc_set_m3_wakeup_flag(u32 flag)
{
		SOC_REG(A7DA_CLKC_CLKC_SW_REG2) = flag;
}

static inline u32 clkc_get_m3_wakeup_flag(void)
{
		return SOC_REG(A7DA_CLKC_CLKC_SW_REG2);
}

static inline void clkc_set_m3_wakeup_addr(u32 addr)
{
		SOC_REG(A7DA_CLKC_CLKC_SW_REG3) = addr;
}

static inline u32 clkc_get_m3_wakeup_addr(void)
{
		return SOC_REG(A7DA_CLKC_CLKC_SW_REG3);
}

/* Tell A7, M3 is ready */
#define BOOT_TEST_M3_READY	0x55AA66BB
static inline void clkc_set_m3_ready_flags(void)
{
		SOC_REG(A7DA_CLKC_CLKC_SW_REG4) = BOOT_TEST_M3_READY;
}

static inline void clkc_clr_m3_ready_flags(void)
{
		SOC_REG(A7DA_CLKC_CLKC_SW_REG4) = 0;
}

/* Wait A7 ready */
#define BOOT_TEST_A7_READY	0x44CC77DD
static inline void clkc_check_a7_ready_flags(void)
{
		while (SOC_REG(A7DA_CLKC_CLKC_SW_REG5) != BOOT_TEST_A7_READY)
				;
}

static inline void clkc_clr_a7_ready_flags(void)
{
		SOC_REG(A7DA_CLKC_CLKC_SW_REG5) = 0;
}

#endif /* __ATLAS7_CLKC_H__ */
